import tensorflow as tf
import keras
from keras.utils import np_utils
from keras.models import Sequential
from keras.layers import Dense
from keras.models import load_model
from sklearn import preprocessing
from sklearn.metrics import confusion_matrix, accuracy_score, classification_report
import numpy as np
import os
import csv


test_labels = []
test_samples = []

#Open file to predict
with open('resultados.txt', 'r') as csvfile:
		spamreader = csv.reader(csvfile, delimiter=' ', quotechar='|')
		for row in spamreader:
				newRow = row[0].split(',')
				
				# NOTA!!: EL ARRAY LABELS TIENE CAMBIARSE A NUMEROS PARA QUE SEA MAS FACIL DE TRABAJAR EN TENSORFLOW
				test_labels.append(newRow.pop(12))
				
				test_samples.append(list(map(float, newRow)))


test_samples = np.array(test_samples)
test_labels = np.array(test_labels)

#Encoding labels to binary matrix
lb = preprocessing.LabelBinarizer()
lb.fit(['A','B','C','D','E','F','G','H','I','K','L','P','T','U','V','W','Y'])

normalize_samples = keras.utils.normalize(test_samples, axis=-1, order=2)


bintest_labels = lb.transform(test_labels)

# load json and create model
model = load_model('sign_language_NN1.h5')
print("Model loaded from disk")

print("Predict and evaluate")

# evaluate loaded model on test data
pred = model.predict(normalize_samples)
print(lb.inverse_transform(pred))


score = model.evaluate(normalize_samples, bintest_labels, verbose=2)
print("%s: %.2f%%" % (model.metrics_names[1], score[1]*100))


confX = lb.inverse_transform(bintest_labels)
confY = lb.inverse_transform(pred)

# print(confX)
# print(confY)

print('confusion')
mat = confusion_matrix(confX, confY)
print(mat)

mat = np.matrix(mat)
print('endconfs')

print(classification_report(confX, confY))

with open('confmat.txt','wb') as f:
    for line in mat:
        np.savetxt(f, line, fmt='%.2f')