import tensorflow as tf
import keras
from keras.utils import np_utils
from keras.models import Sequential
from keras.layers import Dense
from keras.models import load_model
from sklearn.metrics import accuracy_score 
from sklearn import preprocessing
import numpy as np
import os
import csv
import sys


t_labels = []
t_samples = []
line = ""


# Encoding labels to binary matrix
lb = preprocessing.LabelBinarizer()
lb.fit(['A','B','C','D','E','F','G','H','I','K','L','P','T','U','V','W','Y'])

# Loading net
model = load_model('sign_language.h5')
print("Model loaded from disk")


while True:
	#Receiving data from pipeline, only 1 sample per iteration
	line = sys.stdin.readline()
	auxLine = line.split(",")
	t_labels.append(auxLine.pop(12))
	t_samples.append(list(map(float, auxLine)))

	test_samples = np.array(t_samples)
	test_labels = np.array(t_labels)

	bintest_labels = lb.transform(test_labels)
	normtest_samples = keras.utils.normalize(test_samples, axis=-1, order=2)

	#Emptying values for next gesture
	del t_labels[:]
	del t_samples[:]

	#Predicting single gesture and printing it on the screen
	preds = model.predict(normtest_samples, verbose=0)
	preds = lb.inverse_transform(preds)
	print(preds)


